global = {
  \property Staff.autoBeamSettings \override #'(end 1 16 * *) = #(ly:make-moment 1 4)  
  \property Staff.midiInstrument = "church organ"    
  \notes{\key d\minor}
}    

staffUp = {
	\translator Staff = up
}
staffDown = {
	\translator Staff = down
}

leftParAndTrill=\markup{
	\translate #(cons -2 0) {\raise #10 {\musicglyph #"accidentals-leftparen"
	\translate #(cons 0.5 -0.7) {\musicglyph #"scripts-trill"}}}
}
rightPar=\markup{ \musicglyph #"accidentals-rightparen" }


shortTuplets ={
	\property Voice.TupletBracket \override #'bracket-visibility = #'if-no-beam
	\property Voice.TupletBracket \override #'number-visibility = ##f	
	\property Voice.tupletSpannerDuration = #(ly:make-moment 1 8)
	\property Staff.autoBeamSettings \override #'(end 1 24 * *) = #(ly:make-moment 1 8)
}

showTuplet = { \once\property Voice.TupletBracket \set #'number-visibility = ##t }
horizBeam = { \once\property Voice.Beam \set #'damping = #100000 }

soprano =  \context Voice=one \notes \relative c'' {
	\partial 2
		\voiceOne r2 |
		R1*8 |
		r2 r16 a' g a f a e a |
	d, a' cis, a' d, a' e a f a a, a' b, a' cis, a' |
	d, a' cis, a' d, a' e a f a e a d, a' c, a' |
	bes, a' c, a' d, g bes, g' e g d g c, g' bes, g' |
	a, g' bes, g' c, f a, f' d f c f bes, f' a, f' |
	g, f' a, f' bes, e g, e' cis e bes e a, e' g, e' |
	f, e' g, e' a, d f, d' e, e' e, e' f, d' f, d' |
	bes cis bes cis a d f, d' e, e' e, e' f, d' f, d' |
	r d cis d b d cis b cis4 r |
	r16 d cis d f d cis b cis4 e ~|
	e8 d ~ d cis c4 bes |
	a a g g |
	fis8 a4 es'8 d4 r8 g ~|
	g fis g4 bes,8 d d d |
	d4 d8 d d d d d |
	d16 g f g e f d e c a' g a f g e f |
	d bes' a bes g a f g e c' bes c a bes g a |
	f es d c d c bes a bes d bes a g bes g f |
	e f g a bes d c bes a4 c8 bes |
	a g a bes c e, f g |
	a g a bes c16 bes a g f r r8
	
	d'16 c bes a g s8. e'16 d c bes a s8. |
	f'16 e d c bes s8. g'16 f e d c s8. |
	a'16 f e f c f e f a f e f c f e f |
	g e d e c e d e g e d e c e d e |
	a f e f c f e f a f e f c f e f |
	g e d e c e d e g e d e c e d e |
	f g f e d s8. s4 f16 a f d |
	s4 f16 a f d s4 e16 g e c |
	s4 e16 g e c s4 d16 f d bes |
	s4 d16 f d bes s4 cis16 e cis bes |
	s4 cis16 e cis bes r a' g a f a e a |
	d, a' cis, a' d, a' e a f a a, a' b, a' cis, a' |
	f a e a f8[ e] d[ c] bes[ a] |
	bes16 a g f e d cis b \staffDown\voiceOne a16 s8. g16 bes g e |
	s4 g16 bes g e s4 a16 d a f |
	s4 a16 d a f s4 g16 bes g e |
	s4 g16 bes g e s4 a16 d a f |
	s4 a16 d a f s4 bes16 cis bes g |
%FIXME: cross-staff beam should have direction=0
	s4 bes16 cis bes g s4 \staffUp \horizBeam d'16 f d \staffDown a |
	s4 \staffUp \horizBeam d16 f d \staffDown a s4 bes16 cis bes g |
	s4 bes16 cis bes g s4 \staffUp \horizBeam d'16 f d \staffDown a |
	s4 \staffUp \horizBeam d16 f d \staffDown a s4 \staffUp cis16 e cis bes |
	s4 cis16 e cis bes s4 d16 f d s |
	s16 d[ bes] \staffDown s8 a16[ f] s8 d16[ a] s8 d16[ cis b] |
	s16 bes' a g s g f e s bes' a g s g f e |
	\staffUp\oneVoice s4 s16 f' e d a' s8. r16 e' d cis |
	d16 es32 d c bes a g fis8 a ~a g c b |
	es d es b c b c d |
	es d es f 
%FIXME: move trill up (above tie)
		\property Voice.TextSpanner \set #'style = #'trill
		\property Voice.TextSpanner \set #'edge-text
		= #(cons leftParAndTrill rightPar)
		g2 #(ly:export (make-span-event 'TextSpanEvent START)) ~|
	g1 ~|
	g2 ~ g16 #(ly:export (make-span-event 'TextSpanEvent STOP)) g f g es f d es |
	c f es f d es c d bes es d es c d bes c |
	a d c d bes c a bes g bes a bes c bes a g |
	fis8 a d16 g, c fis, bes g d' a bes g a fis |
	g d' fis, d' g, d' a d bes g d' a bes g c a |
	d c bes a bes a bes g a bes c d es d c d |
	bes c a bes g8 b c16 es f g gis g f g |
	es f d es c8 bes a bes ~ bes a ~|
	a g ~ g fis f es ~ es d16 bes' |
	a bes a g fis es' d c bes a' g fis g8. f16 |
	\voiceOne es f d es cis4 d c |
	bes a8 cis d e f4 |
	e2 d4. f8 |
	g d cis d e d cis d |
	e d cis d e g f d |
	bes e d d cis4 d8 e |
	f e f cis d cis d e |
	f e f g a16 bes g a f g e f |
	d a cis a d a e' a, f' a, e' a, f' a, g' a, |
	a' a, e' a, f' a, g' a, a'4 r |
	R1 |
	r2 r16 e d cis d8 r16 f |
	e f g a bes a g a f8 e d16 e f es |
	d c bes a g a bes c a4 r8 c ~|
	c bes r g' es16 f d es c bes a g |
	a4 \staffDown\voiceOne a,16 d a fis s4 a16 d a fis |
	s4 bes16 d bes a s4 bes16 d bes a |
	\staffUp s4 c16 es c bes s4 c16 es c bes |
	s4 g'16 bes g d s4 g16 bes g d |
	s4 fis16 a fis es s4 fis16 a fis es |
	d8 r d' c bes4 c8 d |
	es4 f8 g a4 f8 es |
	d16 es d c bes c bes a g c bes a g a g fis |
	\oneVoice g f e d cis8 e f16 g a b cis d e f |
	g8 f16 e d8 cis d e f g |
	a cis, d e f e f d |
	\voiceOne e d d cis d f e4 |
	<<\new Voice{\stemUp d2\fermata}\new Voice{\stemUp\shiftOn bes2}>>
		r32 f'[ g a bes] s8 c,32[ d es f] s16. |
        s32 a,[ bes c d] s8 g,32[ a bes c] s8 f,32[ g a bes] s8 c,32[ d es f] s16. |
	\staffDown s32 a,[ bes c d] s8 \staffUp bes32[ c d es] s8 c32[ d e fis] s8 fis32[ g a] r c d g, |
	<bes e>2^\Adagissimo ~ <bes e>4 <a d> ~|
	<b d>2 r |
	r4 r8 <b d> <<\new Voice{\stemUp c2 ~| <c e,>2\fermata}
		\new Voice{\stemUp\shiftOn a4. g16 f}>>
		r32 g[ f g e] s8 a32[ g a f] s16. |
	s32 b[ a b g] s8 c32[ b c] s d[ c d] s e[ d e] s f[ e f] s g[ f g e] s16. |
	s32 d[ c d b] s8 c32[ b c a] s8 b32[ a b] s a[ g a] s gis[ fis gis e] s16. |
	s32 d c b s e d c s f e d s g f e s a g f s g a b c4^\Adagio |	
	cis8 s16.^\Vivace a32 cis8 cis d s16. a32 d8 d |
	b s16. g32 b8 b c s16. g32 c8 c |
	a s16. f32 a8 a bes s16. f32 bes8 bes |
	bes s16. cis,32 bes'8 bes a s16. fis32 a8 a ~|
	a4^\MoltoAdagio g2 f4 |
	e2 d ~|
	d1\fermata \bar"|."
		

}
	
alto =  \context Voice=two \notes \relative c'' {
	\staffUp\voiceTwo
	\partial 2
	r2 |
	R1 | r2	r16 d c d bes d a d |
	g, d' fis, d' g, d' a d bes d d, d' e, d' fis, d' |
	g, d' fis, d' g, d' a d bes8^. d^. bes^. d^. |
	es g, es' g, c a c a |
	d f, d' f, bes g bes g |
	cis e, cis' e, a f a f |
	g cis, g' cis, f d f d |
	e \staffDown\stemUp bes \staffUp\stemDown e \staffDown\stemUp\voiceOne bes a a a a |
	a a a a a8. r16 a8 a |
	a a a a a4 d |
	d r c c |
	c r bes bes |
	bes r a a |
	a \staffUp\voiceTwo r8 d cis cis d d |
	e4 r8 d cis cis d d |
	e4 r r16 a g a e g f e |
	f4 d \staffDown\stemUp a16\staffUp\voiceTwo a' g a cis, g' f e |
	f4 e d8 a' ~ a g ~|
	g4 fis f es ~|
	es8 d fis c' ~ c bes16 a bes8 bes |
	a4 d8 c bes a bes fis |
	g fis g a bes a bes fis |
	g16 bes a bes g a f g e c' bes c a bes g a |
	f d' c d bes c a bes g e' d e c d bes c |
	a8 f bes16 a g f g bes g f e g e d |
	c d e f g8 e f4 s4 |
	s1*14 |
	\staffUp\stemUp\shiftOn s4 d'8[ cis] \stemDown d[ \stemUp a] g[ fis] |
	\stemDown g s8 s4 s2 |
	s1*26 |
	\voiceTwo r4 r16 bes a g a4 fis |
	g16 f es d cis8 e f g r \stemUp\shiftOn d' ~|
%FIXME: last e[ a] should have beam underneath f4 in soprano
	d4 cis a16 bes g a f8 a |
	\shiftOff\voiceTwo g a g f g f e a |
	bes a g f a e' d a |
	g g a f e16 a g a f a e a |
	d, a' cis, a' d, a' e a f a a, a' b, a' cis, a' |
	d, a' cis, a' d, a' e a f8 e d g |
	f e f cis d cis d b |
	cis g' f d cis4 r |
	s1*10 |
	s4 g'8 fis g4 g8 b |
	c4 c8 e f4 bes,8 a |
	bes s8 s4 s2 |
	s1*3 |
	r8 a bes a a d d c |
	f,2 s2 |
	s1 |
	s2.. <<\new Voice{\voiceTwo s16 d'16}
		\new Voice{\voiceTwo bes8}>> |
	<e, g>2~ <e g>4 f4 |
	<d f>2 r2 |
	r4 r8 <e gis> e2 |
	s1*3 |
	s2. r8 <c e g> |
	<e a> s r <e a> <a f d> s r <f a> |
	<g d> s r <d g> <g e> s r <e g> |
	<f c> s r <c f> <f d> s r <d f> |
	<g e> s r <g e cis> <d fis> s r <fis d> |
%FIXME: shifted d4's should be merged
	<d bes>2 <cis e>4 <<\new Voice{\stemUp\shiftOn d4}\new Voice{\stemDown\shiftOn d4 ~|
		d}>> c4 ~ c \staffDown\voiceOne bes |
	a1\fermata |
}

tenor =  \context Voice=three \notes \relative c'' {
	\oneVoice
	\partial 2
		%\clef violin
		r16 a g a f a e a |
	d, a' cis, a' d, a' e a f a a, a' b, a' cis, a' |
	d, a' cis, a' d, a' e a f8 fis g c, |
	\clef bass bes a bes c d fis, g a |
	bes a bes fis g16 g' g, g' d g d g |
	c, es c es c es c es c f c f c f c f |
	bes, d bes d bes d bes d bes e bes e bes e bes e |
	a, cis a cis a cis a cis f, d' f, d' f, d' f, d' |
	e, bes' e, bes' e, bes' e, bes' d, a' d, a' d, a' d, a' |
	\voiceTwo e g e g e g e g f8 e d g |
	f e f cis d cis d e |
	f e f cis d4 f |
	g r c, e |
	f r bes, d |
	e r a, cis |
	d r8 f bes bes a a |
	g4 r8 a bes bes a a |
	gis4 r a r |
	R1 |
	r4 r16 a g a fis d' cis d g, f' es d |
	cis e a, cis d, es' d c b d g, b c, d' c bes |
	a c fis, a d, c' bes a \clef violin bes a' g fis g bes, a g |
	d'4 r8 \clef bass d d d d c |
	bes d d c bes d d c |
	bes4 r r2 |
	R1*2 |
	r2 r16 c bes c a c g c |
	f, c' e, c' f, c' g c a c c, c' d, c' e, c' |
	f, c' e, c' f, c' g c a4 \staffUp\voiceTwo s16 es' d c |
	bes8 s s16 f' e d c8 s s16 g' f e |
	d8 s s16 a' g f e8 s s16 bes' a g |
	f8 r c' r f, r c' r |
	e, r c' r e, r c' r |
	f, r c' r f, r c' r |
	e, r c' r e, r c' r |
	d, s s16 c' b a b g b d s4 |
	b16 g b d s4 bes16 g bes c s4 |
	bes16 g bes c s4 a16 f a c s4 |
	a16 f a c s4 g16 e g bes s4 |
	g16 e g bes s4 a8 cis d g, |
	f a b cis d cis d e |
	d cis r16 a g a r fis e fis \staffDown\voiceTwo r d c d |
	bes c bes a g f e d cis a cis e s4 |
	cis16 a cis e s4 d16 a d f s4 |
	d16 a d f s4 cis16 a cis e s4 |
	cis16 a cis e s4 d16 a d f s4 |
	d16 a d f s4 e16 cis e g s4 |
	e16 cis e g s4 f16 d f a s4 |
	f16 d f a s4 e16 cis e g s4 |
	e16 cis e g s4 f16 d f a s4 |
	f16 d f a s4 g16 e g bes s4 |
	g16 e g bes s4 a16 f a cis s8. a16 |
	bes s8 g16[ f] s8 d16[ a] s8 f16[ d] s8. |
	cis'16 s8. f16 s8. d16 s8. f16 s8. |
	d16 e32 f g a b cis d16 s8. \clef violin\oneVoice a16 b32 cis d e f g a16 g f e |
	f8 r r16 es d c bes8 b c g' |
	\property Voice.TextSpanner \set #'style = #'trill
		\property Voice.TextSpanner \set #'edge-text
		= #(cons leftParAndTrill rightPar)
		g1 #(ly:export (make-span-event 'TextSpanEvent START)) ~|
	g2 ~ g16 #(ly:export (make-span-event 'TextSpanEvent STOP)) g f g es g d g |
	c, g' b, g' c, g' d g es g g, g' a, g' b, g' |
	c, g' b, g' c, g' d g es8 d g16 gis f g |
	es8 c f16 g es f d8 bes es16 f d es |
	c8 fis g16 a f g es g fis g a g fis e |
	\clef bass r d c d bes d a d g, d' fis, d' g, d' a d |
	bes d d, d' e, d' fis, d' g, d' fis, d' g, d' a d |
	bes8 a g4 ~ g fis |
	g8 a bes16 a g f es8 es' d4 |
	\clef violin c8 d es16 f d es c es d f g f es f |
	d bes es d \clef bass cis a d c b g c bes a f bes d |
	c d c bes a c bes a g c bes a bes c bes a |
	g a f g e4 <<\new Voice{\stemUp r16 es' d c d c bes a | g4 s2 \staffUp\stemDown a'16 g a f}
		\new Voice{\stemDown fis,4 d | g a16 bes a g f g e a d,4}>> |
	\staffUp\voiceTwo g'16 a g a bes a g a f g f g d \staffDown \oneVoice c bes a |
	bes a g f e f e d cis a d a e' a, f' a, |
	g' a, f' a, e' a, d a cis a' a, a' d, a' f d' |
	g, d' e, cis' f, d' d, d' a2 ~|
	a1 ~|
	a1 ~|	
	a1 ~|
	a2 ~ a4 r |
	R1 |
	r2 \clef violin r16 g' f e f cis d8 ~|
	d4 cis d16 a' b cis d c d8 |
	\clef bass f,4. es8 ~ es16 c a f a c es c |
	d bes g d g bes d g c, d bes c a g fis e |
	\voiceTwo fis d fis g s4 fis16 d fis g s4 |
	g16 d g a s4 g16 d g a s4 |
	\oneVoice a16 fis a bes s4 a16 fis a bes s4 |
	a16 bes d fis s4 bes,16 g bes d s4 |
	c16 a c es s4 c16 a c es s4 |
	fis,8 r g a bes4 es8 b |
	g4 c8 bes a4 bes8 c |
	d16 g f es d es d c bes es d c bes c bes a |
	bes a g f e8 g a16 b cis d \clef violin e f g a |
	bes8 a16 g f a e a d, a' cis, a' d, a' e a |
	f a a, a' b, a' cis, a' d, a' cis, a' d, a' b, a' |
	cis,8 d g e f a bes a |
	\clef bass <<
		\new Voice{\stemUp d,2\fermata}
		\new Voice{\stemUp\shiftOn bes2}
		\new Voice{\stemDown f2}>>
%		\property Voice.autoBeamSettings \override #'(* * * * *) = #(ly:make-moment 1 1)
		s8^\Recitativo \staffUp \voiceTwo s32 a'[ bes c d] s8 f,32[ g a] |
	bes s8 a32[ g f es] s8 g32[ f es d] s8 \staffDown a32[ bes c d] s8 f,32[ g a] |
	bes s8 c32[ bes a g] s8 d'32[ c bes a] s8 \staffUp es'32[ d c bes] \staffDown s16. r16 g |
	cis2 ~ cis4 d |
	b2 r |
	r4 r8 <<\new Voice{\stemUp\tieUp b8 c2 ~| c2\fermata}
		\new Voice{\stemDown\tieDown <gis e>8 <a e>2 ~| <e g>}>>
		 s32^\Presto \staffUp s8 e'32[ d e c] s8 f32[ e f] |
	d32 s8 g32[ f g e] s16. a32 s16. b32 s16. c32 s16. d32 s8 c32[ b c] |
	a s8 gis32[ fis gis e] s8 f32[ e f d] s16. c32 s16. b32 s8 \staffDown c32[ b a] |
	gis s16. a32 s16. b32 s16. c32 s16. \staffUp d32 s16. e32 s16. \staffDown\voiceTwo r8 g,8 |
	a8 a32 \staffUp cis e s \staffDown r8 a, a a32 \staffUp d f s \staffDown r8 a, |
	g8 g32 b \staffUp d s \staffDown r8 g, g g32 \staffUp c e s \staffDown r8 g, |
	a8 f32 a \staffUp c s \staffDown r8 f, f f32 bes32 \staffUp d s \staffDown r8 f, |
	e8 e32 g bes s r8 e, fis d32 a'32 \staffUp d s \staffDown r8 fis, |
	g2 bes4 a |
	a2 f4 g |
	f1 |
}

basso =  \context Voice=four \notes \relative c {
	\partial 2
		r2 |
	R1*21 |
	r16 d c d bes d a d g, d' fis, d' g, d' a d |
	bes d d, d' e, d' fis, d' g, d' fis, d' g, d' a d |
	bes4 r8 b c4 r8 cis |
	d4 r8 d e4 r8 e |
	f a, bes d g,4 r8 bes ~|
	bes a g c f,4 r |
	R1*28 |
	r2 r16 g' f g es g d g |
	c, g' b, g' c, g' d g es g g, g' a, g' b, g' |
	c, g' b, g' c, g' d g es8 d c b |
	c d es f g b, c d |
	es d es f g b, c d |
	es a, bes c d g, a bes |
	c d g d es bes a c |
	d1 ~|
	d ~|
	d4 r8 g, c a d d, |
	g4 r8 g c4. b8 |
	c4 r r2 |
	R1*11 |
	r2 r16 a' g a f a e a |
	d, a' cis, a' d, a' e a f a a, a' b, a' cis, a' |
	d, a' cis, a' d, a' e a f4 r8 f |
	g e a a, d4 r8 a |
	bes g c c, f4 r8 a |
	bes4 r8 bes c4 r8 a |
	d4 r d r |
	d r d r |
	d r d r |	
	d r d r |	
	d r d r |
	r16 d c d bes d a d g, g' f g es g d g |
	c, c bes c a c g c f, f' es f d f c f |
	bes,8 es f f, g c d d, |
	g4 r16 a g a f8 d a'4 |
	d,1 ~|
	d2 r4 r8 d' |
	a f g a f d g a |
	bes2\fermata r |
	R1*2 |
	cis2( f4.) d8 |
	gis,2 r16 gis' b f gis d f  b, |
	d gis, a8 e2. |
	e2\fermata r2 |
	R1*2 |
	r2 r4 r8 e' |
	g r r g f r r f |
	f r r f e r r e |
	e r r e d r r d |
	cis r r cis c r r c |
	g4 bes e, f |
	a2 bes4 g |
	<d d'>1\fermata |
	
}

#(ly:set-point-and-click 'line-column)

\score{
	<<
		\context PianoStaff <<
			\context Staff=up<<
				\global
				\time 4/4
				\clef violin
				\soprano
				\alto
			>>
			\context Staff=down<<
				\global
				\clef violin
				\tenor
			>>
		>>
		\context Staff=pedal<<
			\global
			\clef bass
			\basso
		>>
	>>
	\paper{ indent = 0 }
	\midi{ \tempo 4 = 80 }
	\header {
		piece = "Fuga"
	}
}
