global = {
  \property Staff.autoBeamSettings \override #'(end 1 16 * *) = #(ly:make-moment 1 4)  
  \property Staff.midiInstrument = "church organ"    
  \notes{\key d\minor}
}    

staffUp = {
	\translator Staff = up
}
staffDown = {
	\translator Staff = down
}

leftParAndTrill=\markup{
	\translate #(cons -2 0) {\musicglyph #"accidentals-leftparen"
	\translate #(cons 0.5 -0.7) {\musicglyph #"scripts-trill"}}
}
rightPar=\markup{" " \musicglyph #"accidentals-rightparen" }


shortTuplets ={
	\property Voice.TupletBracket \override #'bracket-visibility = #'if-no-beam
	\property Voice.TupletBracket \override #'number-visibility = ##f	
	\property Voice.tupletSpannerDuration = #(ly:make-moment 1 8)
	\property Staff.autoBeamSettings \override #'(end 1 24 * *) = #(ly:make-moment 1 8)
}

showTuplet = { \once\property Voice.TupletBracket \set #'number-visibility = ##t }



soprano =  \context Voice=one \notes \relative c'' {
\voiceOne
	a'8\mordent\fermata^\Adagio r32 g64 f e d cis32 d16 r16\fermata r8
		a\mordent\fermata r32 e f cis d16 r\fermata r8 |
	a\mordent\fermata \staffDown r32 g64 f e d cis32 d16 r\fermata r8
		r4 \staffUp <cis' e>4\arpeggio ~|
%FIXME: cis~cis should be \tieDown
	<cis e>4 d r r8 r16 
	\shortTuplets
		cis |
	\showTuplet\times 2/3 {d16^\Prestissimo e cis d e cis d e cis} d e \showTuplet\times 2/3 {f g e f g e f g e} f g |
	\showTuplet\times 2/3 {a bes g a bes g a bes g} a r\fermata r4 r8 r16
%% SAME THING	
		cis |
	\showTuplet\times 2/3 {d16 e cis d e cis d e cis} d e \showTuplet\times 2/3 {f g e f g e f g e} f g |
	\showTuplet\times 2/3 {a bes g a bes g a bes g}	a r\fermata r4 r8 r16
		a |
	\showTuplet\times 2/3 {g bes e, g bes e, f a d, f a d, e g c, e g c, d f bes, d f bes, |
		c e a, c e a, bes d g, bes d g, a c f, a c f, g bes e, g bes e, |
		f a d, f a d, e g cis, e g cis,}
		r4 <<\new Voice{\tieUp <g' bes>4\arpeggio^\lento ~| <g bes>~ bes32[ a g f e] d[ cis b] cis16[ \staffDown a \staffUp cis] e32[ g] f8.\trill e16 | f4\fermata}
			\new Voice{\stemDown\tieDown <cis e>4\arpeggio ~| <cis e> s2. | d4}>>
	r8^\Allegro\oneVoice r16 a'16 d-. e-. f-. d-. e-. f-. g-. e-. |
	f g a f g a bes g a f g e f d e cis |
	d a bes g a f g e f d e cis f d e cis |
	\clef bass d a bes g a f g e f d g e f d e cis |
	d8 \clef violin \voiceOne s32 f' bes f s e a e s d g d s s e a r16 <f bes> r <e a> r <d g> |
	<<\new Voice{\stemUp<e a>8} \new Voice{\stemDown cis8}>>
		s32 f bes f s e a e s d g d s s e a r16 <f bes> r <e a> r <d g> |
	<<\new Voice{\stemUp\tieUp<e a>4 ~ a32 g f e} \new Voice{\stemDown cis4}>>
		d32 cis b cis \staffDown\stemUp a b cis d \staffUp e[ f g a g f e f] \stemDown d[ f] \stemUp a[ cis] |
	d16 s8 e32[ f g a bes16] r16 <f bes> r <e a> r <d g> <a' e cis>8 s32 f bes f |
	s e a e s d g d s s e a r16 <f bes> r <e a> r <d g> <a' e cis>8 <d, b> |
	<<\new Voice{\stemUp cis8. b16}\new Voice{\stemUp\shiftOn a4}>> a16 cis
	e32 g bes16\fermata a32[ g f e f e d cis] d[ c bes a] \stemDown g[ f e d] \stemUp |
	
	<<\new Voice{\stemUp\tieUp <cis' e>2~
		\shortTuplets
		\showTuplet\times 2/3{cis16^\Prestissimo e cis bes cis bes cis e cis bes cis bes}}
		\new Voice{\stemDown bes2}>> |
	\times2/3{cis16 e cis bes cis bes cis e cis bes cis bes g bes g e g e g bes g e g e g bes g e g e g bes g e g e cis e cis bes cis bes cis e cis bes cis bes cis e cis bes cis bes cis e cis bes cis bes cis e cis e g e cis e cis e g e cis e cis e g e cis e cis e g e g bes g bes g bes g bes g bes g bes cis bes cis e cis e cis e cis e cis e}
	<<\new Voice{\stemUp<a, cis e a>4 <a d f a> |
		<bes d g> r <a cis e g> r |
		r r8 r16 <a cis> <f a d>8 f e4 |
		d2}
	\new Voice{\stemDown\tieDown <cis e>4 <d f> |
		<d g> r <cis e> r |
		r  r8 r16 e d8[ d] ~ d[ cis] |
		\staffDown\stemUp a2}>> \bar "||"
}
	
alto =  \context Voice=two \notes \relative c'' {
\voiceTwo
%FIXME?: mordent and fermata up
	a8\mordent\fermata r32 g64 f e d cis32 d16 r16\fermata r8 \staffDown a\mordent\fermata r32 e f cis d16 r\fermata r8 |
	a\mordent\fermata \staffDown r32 g64 f e d cis32 d16 r\fermata r8
	\property PianoStaff.connectArpeggios = ##t
		r4 << \new Voice{\stemUp\shiftOff s4 | s a'' }
			\new Voice {\stemUp\tieUp <e g b>4\arpeggio ~ | <e g b> ~\tieDown\shiftOn g16 e fis8 r4 r8}\\
			\new Voice {\stemDown\tieDown cis4\arpeggio ~| cis d r r8} >>
			r16 cis |
	\shortTuplets			
%% SAME THING	
	\showTuplet\times 2/3 {d16 e cis d e cis d e cis} d e \showTuplet\times 2/3 {f g e f g e f g e} f g |
	\showTuplet\times 2/3 {a bes g a bes g a bes g} a r\fermata r4 r8 r16 
%% SAME THING
		\clef violin cis |
	\showTuplet\times 2/3 {d16 e cis d e cis d e cis} d e \showTuplet\times 2/3 {f g e f g e f g e} f g |
	\showTuplet\times 2/3 {a bes g a bes g a bes g}
	a r\fermata r4 r8 r16 a |
	\showTuplet \times 2/3 {g bes e, g bes e, f a d, f a d, e g c, e g c, d f bes, d f bes, |
		\clef bass c e a, c e a, bes d g, bes d g, a c f, a c f, g bes e, g bes e, |
		f a d, f a d, e g cis, e g cis,}
		r4 <<\new Voice{\stemUp\tieUp <g' bes>4\arpeggio ~| <g bes> s2. | <f a>4}
			\new Voice{\stemDown\tieDown <cis e>4\arpeggio | <cis e> s2. |d4}>>
		r4 \clef violin r32 a''16 a a a a a a a32 |
	r32 a16 a a a a a a a a a a a a a a a32 |
	r32 a16 a a a a a a a a a a a a a a a32 |		
	r32 a16 a a a a a a a a a a a a a a a32 |
	\clef bass \staffUp s8 d,32 s16. c32 s16. bes32 s16. \staffDown\stemUp a32\staffUp\stemDown cis s16 d16 r \staffDown a r bes r |
	e,8 \staffUp d'32 s16. c32 s16. bes32 s16. \staffDown\stemUp a32\staffUp\stemDown cis s16 d16 r \staffDown a r bes r |
	e,4 r r2 |
	\staffUp s16 a'32[ b cis d] s8. d16 r a r bes r e,8 d'32 s16. |
	c32 s16. bes32 s16. a32 cis s16 d r a r bes r e,8 <f d b>|
	\staffDown a4 r r2 \clef violin |
	<<\new Voice{
		\shortTuplets
		\stemUp\tieUp<e g>2~\showTuplet\times 2/3{e16 g e cis e cis e g e cis e cis}}
		\new Voice{\stemDown cis2}>>
	\times 2/3{e16 g e cis e cis e g e cis e cis \clef bass bes cis bes g bes g bes cis bes g bes g | bes cis bes g bes g bes cis bes g bes g e g e cis e cis e g e cis e cis | e g e cis e cis e g e cis e cis e g e g bes g e g e g bes g | e g e g bes g e g e g bes g e g e g e g bes cis bes cis bes cis | e cis e cis e cis e cis e cis e cis}
		a4 a |
		s1 |
	<<\new Voice{\stemDown\tieUp r4 r8 r16 a a8[ a]~ a8.[ g16]~ | \shiftOn\stemUp g8 f16 e f4}
		\new Voice{\stemDown s1 | d2}>> \clef violin
}

tenor =  \context Voice=three \notes \relative c'' {
%\voiceThree\stemBoth
	\voiceTwo
	s1*29 |
	s2
}

basso =  \context Voice=four \notes \relative c {
	R1 |
	r2 d,2 ~|
	d r |
	R1*6 |
	r2 d2 ~ |
	d4 r r2 |
	d4\fermata r r2 |
	R1*3 |
	r2 r8 d' c bes |
	a r r4 r8 d c bes |
	a4 r r2 |
	r4 r8 d c bes a r |
	r4 r8 d c bes a gis |
	g4 r r2 |
	g'2 r |
	R1*4 |
	r2 g4^\markup{\italic (maestoso)} f |
	bes4. a16[ g] a8.[ e16] f[ d e cis] |
	d[b cis a] bes[ gis a g'] f8 d a4 |
	d,2
}

#(ly:set-point-and-click 'line-column)

\score{
	<<
		\context PianoStaff <<
			\context Staff=up<<
				\global
				\time 4/4
				\clef violin
				\soprano
				\alto
			>>
			\context Staff=down<<
				\global
				\clef bass
				\tenor
			>>
		>>
		\context Staff=pedal<<
			\global
			\clef bass
			\basso
		>>
	>>
	\paper{ }
	\midi{ \tempo 4 = 80 }
	\header {
		piece = "Toccata"
	}
}
